/* IRangeTests.java 1.0  12 December 2002 */

public class IRangeTests extends JPFalt 
{
    public static void main(String[] args) { new IRangeTests(); }
    
    ///////////////////////////////////////////////////////////
    // Place your actual methods here.                       //
    ///////////////////////////////////////////////////////////

    void printer(IRange i) { 
        console.out.print("["); 
        for(IRange r = i; r.hasMore(); r.next())
            console.out.print(" " + r.current() + " "); 
        console.out.println("]"); 
    }


    public boolean filter(int n, IRange i){
        for (IRange r = i; r.hasMore(); r.next()){
            if (((Integer)r.current()).intValue() == n)
                return true;
        }
        return false;
    }

    void TestIterator() {
        AListOfInt l = 
            new ConsInt(new Integer(1), 
                     new ConsInt(new Integer(3),
                              new ConsInt(new Integer(4),
                                       new EmptyListOfInt())));
                                       
        
        expected(false);                               
        actual(filter(5, new ListRange(l)));
        
        expected(true);                               
        actual(filter(1, new ListRange(l)));
        
        expected(true);                               
        actual(filter(4, new ListRange(l)));

        Object o[] = new Object[]{new Integer(1),
                                  new Integer(3),
                                  new Integer(4)};


        // manual 
        console.out.print("["); 
        for(IRange r = new ListRange(l); r.hasMore(); r.next())
            console.out.print(" " + r.current() + " "); 
        console.out.println("]"); 


        // abstract and use a function that prints everything in a range 
        printer(new ListRange(l)); 


        // ... it really works on both
        printer(new ArrayRange(o)); 
    }
    
    /*--------------------------------------------------------
     Binary Trees
     -------------------------------------------------------*/
    void TestBinTree(){
    
        ABinTreeInt empty = new EmptyBinTreeInt();
        ConsBinTreeInt myTree = 
            new ConsBinTreeInt(new Integer(5), empty, empty);
            
        println(myTree);
        
        ConsBinTreeInt newTree = myTree.insert(new Integer(3))
                .insert(new Integer(8))
                    .insert(new Integer(2))
                        .insert(new Integer(6));
        println(newTree);
        
        println("******* TreeTraversal **********");       
        printer(new TreeRange(newTree));
    }

    /*--------------------------------------------------------
     Binary Trees
     -------------------------------------------------------*/
    void TestReverseBinTree(){
    
        ABinTreeInt empty = new EmptyBinTreeInt();
        ConsBinTreeInt myTree = 
            new ConsBinTreeInt(new Integer(5), empty, empty);
            
        println(myTree);
        
        ConsBinTreeInt newTree = myTree.insert(new Integer(3))
                .insert(new Integer(8))
                    .insert(new Integer(2))
                        .insert(new Integer(6));
        println(newTree);
        
        println("******* Reverse TreeTraversal **********");       
        printer(new ReverseTreeRange(newTree));
    }

    	/*--------------------------------------------------------------------- 
    	 Stock format for comments and definitions 
    	---------------------------------------------------------------------*/
}
